DROP USER UOC CASCADE;

CREATE USER UOC
  IDENTIFIED BY <password>
  DEFAULT TABLESPACE SYSTEM
  TEMPORARY TABLESPACE TEMP
  PROFILE DEFAULT
  ACCOUNT UNLOCK;
  -- 2 Roles for UOC 
  GRANT RESOURCE TO UOC WITH ADMIN OPTION;
  GRANT CONNECT TO UOC WITH ADMIN OPTION;
  ALTER USER UOC DEFAULT ROLE ALL;
  -- 200 System Privileges for UOC 
  GRANT ADMINISTER SQL MANAGEMENT OBJECT TO UOC;
  GRANT INSERT ANY MEASURE FOLDER TO UOC;
  GRANT DROP ANY CUBE DIMENSION TO UOC;
  GRANT DELETE ANY CUBE DIMENSION TO UOC;
  GRANT ALTER ANY CUBE DIMENSION TO UOC;
  GRANT CREATE MINING MODEL TO UOC;
  GRANT CREATE ANY EDITION TO UOC;
  GRANT MANAGE FILE GROUP TO UOC;
  GRANT ADMINISTER ANY SQL TUNING SET TO UOC;
  GRANT MANAGE SCHEDULER TO UOC;
  GRANT ADVISOR TO UOC;
  GRANT IMPORT FULL DATABASE TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.EXECUTE_ANY_RULE_SET,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT ON COMMIT REFRESH TO UOC;
  GRANT CREATE ANY OUTLINE TO UOC;
  BEGIN
SYS.DBMS_AQADM.GRANT_SYSTEM_PRIVILEGE (
  PRIVILEGE    => 'MANAGE_ANY',
  GRANTEE      => 'UOC',
  ADMIN_OPTION => FALSE);
END;
/
  GRANT DROP ANY DIMENSION TO UOC;
  GRANT ALTER ANY DIMENSION TO UOC;
  GRANT GLOBAL QUERY REWRITE TO UOC;
  GRANT ALTER ANY OPERATOR TO UOC;
  GRANT DROP ANY TYPE TO UOC;
  GRANT CREATE ANY TRIGGER TO UOC;
  GRANT CREATE TRIGGER TO UOC;
  GRANT ALTER ANY PROCEDURE TO UOC;
  GRANT FORCE ANY TRANSACTION TO UOC;
  GRANT CREATE ROLE TO UOC;
  GRANT CREATE SEQUENCE TO UOC;
  GRANT CREATE ANY VIEW TO UOC;
  GRANT CREATE SYNONYM TO UOC;
  GRANT CREATE ANY INDEX TO UOC;
  GRANT DROP ANY CLUSTER TO UOC;
  GRANT CREATE ROLLBACK SEGMENT TO UOC;
  GRANT BECOME USER TO UOC;
  GRANT CREATE USER TO UOC;
  GRANT CREATE SESSION TO UOC;
  GRANT FLASHBACK ARCHIVE ADMINISTER TO UOC;
  GRANT DROP ANY MEASURE FOLDER TO UOC;
  GRANT CREATE CUBE TO UOC;
  GRANT SELECT ANY CUBE DIMENSION TO UOC;
  GRANT ALTER ANY MINING MODEL TO UOC;
  GRANT CREATE ASSEMBLY TO UOC;
  GRANT EXECUTE ANY CLASS TO UOC;
  GRANT FLASHBACK ANY TABLE TO UOC;
  GRANT CREATE ANY DIMENSION TO UOC;
  GRANT ALTER ANY INDEXTYPE TO UOC;
  GRANT CREATE ANY TYPE TO UOC;
  GRANT DROP ANY TRIGGER TO UOC;
  GRANT EXECUTE ANY PROCEDURE TO UOC;
  GRANT CREATE PUBLIC DATABASE LINK TO UOC;
  GRANT SELECT ANY SEQUENCE TO UOC;
  GRANT CREATE ANY SEQUENCE TO UOC;
  GRANT CREATE VIEW TO UOC;
  GRANT CREATE PUBLIC SYNONYM TO UOC;
  GRANT SELECT ANY TABLE TO UOC;
  GRANT COMMENT ANY TABLE TO UOC;
  GRANT DROP ROLLBACK SEGMENT TO UOC;
  GRANT RESTRICTED SESSION TO UOC;
  GRANT ALTER SESSION TO UOC;
  GRANT DROP ANY CUBE BUILD PROCESS TO UOC;
  GRANT DROP ANY MINING MODEL TO UOC;
  GRANT CHANGE NOTIFICATION TO UOC;
  GRANT ADMINISTER SQL TUNING SET TO UOC;
  GRANT SELECT ANY TRANSACTION TO UOC;
  GRANT CREATE JOB TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.DROP_ANY_RULE,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.CREATE_RULE_OBJ,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.CREATE_RULE_SET_OBJ,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.ALTER_ANY_EVALUATION_CONTEXT,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT ADMINISTER DATABASE TRIGGER TO UOC;
  BEGIN
SYS.DBMS_AQADM.GRANT_SYSTEM_PRIVILEGE (
  PRIVILEGE    => 'ENQUEUE_ANY',
  GRANTEE      => 'UOC',
  ADMIN_OPTION => FALSE);
END;
/
  GRANT QUERY REWRITE TO UOC;
  GRANT CREATE ANY OPERATOR TO UOC;
  GRANT UNDER ANY TYPE TO UOC;
  GRANT ALTER ANY TRIGGER TO UOC;
  GRANT CREATE ANY PROCEDURE TO UOC;
  GRANT DROP PUBLIC DATABASE LINK TO UOC;
  GRANT CREATE DATABASE LINK TO UOC;
  GRANT CREATE ANY CLUSTER TO UOC;
  GRANT CREATE TABLESPACE TO UOC;
  GRANT CREATE CUBE BUILD PROCESS TO UOC;
  GRANT CREATE ANY MEASURE FOLDER TO UOC;
  GRANT INSERT ANY CUBE DIMENSION TO UOC;
  GRANT ALTER ANY ASSEMBLY TO UOC;
  GRANT READ ANY FILE GROUP TO UOC;
  GRANT EXPORT FULL DATABASE TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.DROP_ANY_RULE_SET,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT DROP ANY OUTLINE TO UOC;
  GRANT DROP ANY CONTEXT TO UOC;
  GRANT UNDER ANY TABLE TO UOC;
  GRANT CREATE ANY INDEXTYPE TO UOC;
  GRANT EXECUTE ANY TYPE TO UOC;
  GRANT CREATE ANY DIRECTORY TO UOC;
  GRANT CREATE MATERIALIZED VIEW TO UOC;
  GRANT ANALYZE ANY TO UOC;
  GRANT DROP PROFILE TO UOC;
  GRANT DROP ANY PROCEDURE TO UOC;
  GRANT ALTER ANY SEQUENCE TO UOC;
  GRANT DROP PUBLIC SYNONYM TO UOC;
  GRANT INSERT ANY TABLE TO UOC;
  GRANT BACKUP ANY TABLE TO UOC;
  GRANT ALTER ROLLBACK SEGMENT TO UOC;
  GRANT ALTER SYSTEM TO UOC;
  GRANT DROP ANY CUBE TO UOC;
  GRANT ALTER ANY CUBE TO UOC;
  GRANT CREATE ANY ASSEMBLY TO UOC;
  GRANT ALTER ANY SQL PROFILE TO UOC;
  GRANT EXECUTE ANY PROGRAM TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.ALTER_ANY_RULE_SET,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.CREATE_ANY_EVALUATION_CONTEXT,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT DEBUG CONNECT SESSION TO UOC;
  BEGIN
SYS.DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SYSTEM_PRIVILEGE
  (GRANTEE_NAME   => 'UOC', 
   PRIVILEGE_NAME => 'ADMINISTER_RESOURCE_MANAGER',
   ADMIN_OPTION   => FALSE);
END;
/
  BEGIN
SYS.DBMS_AQADM.GRANT_SYSTEM_PRIVILEGE (
  PRIVILEGE    => 'DEQUEUE_ANY',
  GRANTEE      => 'UOC',
  ADMIN_OPTION => FALSE);
END;
/
  GRANT DROP ANY OPERATOR TO UOC;
  GRANT CREATE OPERATOR TO UOC;
  GRANT ALTER ANY LIBRARY TO UOC;
  GRANT CREATE PROCEDURE TO UOC;
  GRANT DROP ANY INDEX TO UOC;
  GRANT DROP USER TO UOC;
  GRANT UPDATE ANY CUBE TO UOC;
  GRANT SELECT ANY CUBE TO UOC;
  GRANT DROP ANY ASSEMBLY TO UOC;
  GRANT ALTER ANY EDITION TO UOC;
  GRANT CREATE ANY SQL PROFILE TO UOC;
  GRANT CREATE ANY JOB TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.EXECUTE_ANY_RULE,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.ALTER_ANY_RULE,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.CREATE_ANY_RULE_SET,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.CREATE_EVALUATION_CONTEXT_OBJ,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT EXECUTE ANY INDEXTYPE TO UOC;
  GRANT EXECUTE ANY OPERATOR TO UOC;
  GRANT EXECUTE ANY LIBRARY TO UOC;
  GRANT CREATE ANY LIBRARY TO UOC;
  GRANT ALTER ANY MATERIALIZED VIEW TO UOC;
  GRANT ALTER RESOURCE COST TO UOC;
  GRANT ALTER PROFILE TO UOC;
  GRANT AUDIT ANY TO UOC;
  GRANT ALTER ANY ROLE TO UOC;
  GRANT DROP ANY SEQUENCE TO UOC;
  GRANT DROP ANY SYNONYM TO UOC;
  GRANT ALTER ANY INDEX TO UOC;
  GRANT ALTER ANY CLUSTER TO UOC;
  GRANT CREATE CLUSTER TO UOC;
  GRANT LOCK ANY TABLE TO UOC;
  GRANT UNLIMITED TABLESPACE TO UOC WITH ADMIN OPTION;
  GRANT DROP TABLESPACE TO UOC;
  GRANT AUDIT SYSTEM TO UOC;
  GRANT UPDATE ANY CUBE DIMENSION TO UOC;
  GRANT UPDATE ANY CUBE BUILD PROCESS TO UOC;
  GRANT CREATE ANY CUBE BUILD PROCESS TO UOC;
  GRANT CREATE ANY CUBE TO UOC;
  GRANT CREATE CUBE DIMENSION TO UOC;
  GRANT COMMENT ANY MINING MODEL TO UOC;
  GRANT SELECT ANY MINING MODEL TO UOC;
  GRANT CREATE ANY MINING MODEL TO UOC;
  GRANT EXECUTE ASSEMBLY TO UOC;
  GRANT DROP ANY EDITION TO UOC;
  GRANT MANAGE ANY FILE GROUP TO UOC;
  GRANT DROP ANY SQL PROFILE TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.CREATE_ANY_RULE,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.DROP_ANY_EVALUATION_CONTEXT,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT GRANT ANY OBJECT PRIVILEGE TO UOC;
  GRANT DEBUG ANY PROCEDURE TO UOC;
  GRANT RESUMABLE TO UOC;
  GRANT ALTER ANY OUTLINE TO UOC;
  GRANT UNDER ANY VIEW TO UOC;
  GRANT CREATE INDEXTYPE TO UOC;
  GRANT CREATE PROFILE TO UOC;
  GRANT ALTER DATABASE TO UOC;
  GRANT DROP ANY ROLE TO UOC;
  GRANT CREATE ANY SYNONYM TO UOC;
  GRANT UPDATE ANY TABLE TO UOC;
  GRANT DROP ANY TABLE TO UOC;
  GRANT ALTER ANY TABLE TO UOC;
  GRANT CREATE ANY TABLE TO UOC;
  GRANT CREATE TABLE TO UOC;
  GRANT ALTER USER TO UOC;
  GRANT MANAGE TABLESPACE TO UOC;
  GRANT ALTER TABLESPACE TO UOC;
  GRANT DELETE ANY MEASURE FOLDER TO UOC;
  GRANT CREATE MEASURE FOLDER TO UOC;
  GRANT CREATE ANY CUBE DIMENSION TO UOC;
  GRANT EXECUTE ANY ASSEMBLY TO UOC;
  GRANT CREATE EXTERNAL JOB TO UOC;
  BEGIN
SYS.DBMS_RULE_ADM.GRANT_SYSTEM_PRIVILEGE(
  PRIVILEGE    => SYS.DBMS_RULE_ADM.EXECUTE_ANY_EVALUATION_CONTEXT,
  GRANTEE      => 'UOC',
  GRANT_OPTION => FALSE);
END;
/
  GRANT MERGE ANY VIEW TO UOC;
  GRANT CREATE ANY CONTEXT TO UOC;
  GRANT CREATE DIMENSION TO UOC;
  GRANT DROP ANY INDEXTYPE TO UOC;
  GRANT DROP ANY LIBRARY TO UOC;
  GRANT CREATE LIBRARY TO UOC;
  GRANT ALTER ANY TYPE TO UOC;
  GRANT CREATE TYPE TO UOC;
  GRANT DROP ANY DIRECTORY TO UOC;
  GRANT DROP ANY MATERIALIZED VIEW TO UOC;
  GRANT CREATE ANY MATERIALIZED VIEW TO UOC;
  GRANT GRANT ANY PRIVILEGE TO UOC;
  GRANT FORCE TRANSACTION TO UOC;
  GRANT GRANT ANY ROLE TO UOC;
  GRANT DROP ANY VIEW TO UOC;
  GRANT DELETE ANY TABLE TO UOC;
  -- 2 Object Privileges for UOC 
    GRANT EXECUTE ON SYS.DBMS_OBFUSCATION_TOOLKIT TO UOC;
    GRANT EXECUTE ON SYS.UTL_RAW TO UOC;
