--
-- Create Schema Script 
--   Database Version   : 11.2.0.2.0 
--   Toad Version       : 10.6.1.3 
--   DB Connect String  : XE 
--   Schema             : UOC 
--   Script Created by  : UOC 
--   Script Created at  : 1/14/2013 6:12:00 PM 
--   Physical Location  :  
--   Notes              :  
--

-- Object Counts: 
--   Directories: 0 
--   Tables: 25         Columns: 211        
--   Views: 1           Columns: 11         


CREATE TABLE DWH_CLIENTE
(
  CLI_ID         NUMBER,
  CLI_NOMBRE     VARCHAR2(20 BYTE),
  CLI_APELLIDO   VARCHAR2(50 BYTE),
  CLI_TELEFONO   VARCHAR2(15 BYTE),
  CLI_EMAIL      VARCHAR2(30 BYTE),
  CLI_PROFESION  VARCHAR2(20 BYTE),
  CLI_FNAC       DATE,
  CLI_FECHAALTA  DATE
)
NOCOMPRESS ;


CREATE TABLE DWH_FACTURACION
(
  FAC_ID             NUMBER,
  FAC_CONTABILIZADA  CHAR(1 BYTE),
  FAC_FECHA          DATE,
  FAC_TOTAL          NUMBER,
  FAC_CONCEPTO       VARCHAR2(100 BYTE),
  FAC_IMPORTELIN     NUMBER
)
NOCOMPRESS ;


CREATE TABLE DWH_EMPLEADO
(
  EMP_ID             NUMBER,
  EMP_CONID          NUMBER,
  EMP_CONCESIONARIO  VARCHAR2(50 BYTE),
  EMP_NOMBRE         VARCHAR2(25 BYTE),
  EMP_APELLIDOS      VARCHAR2(59 BYTE),
  EMP_DIRECCION      VARCHAR2(100 BYTE),
  EMP_TELEFONO       VARCHAR2(15 BYTE),
  EMP_NSS            VARCHAR2(10 BYTE),
  EMP_DNI            VARCHAR2(15 BYTE),
  EMP_SUELDO         NUMBER,
  EMP_COSTE          NUMBER,
  EMP_JEFE           CHAR(1 BYTE),
  EMP_TIPOEMP        CHAR(1 BYTE),
  EMP_FACHAALTA      DATE
)
NOCOMPRESS ;


CREATE TABLE DWH_REPARACION
(
  REP_FECHAINICIO  DATE,
  REP_FECHAFIN     DATE,
  REP_REVISION     VARCHAR2(1 BYTE),
  REP_FACID        NUMBER,
  REP_EMPREP       NUMBER,
  REP_CONCEPTO     VARCHAR2(100 BYTE),
  REP_HORAS        NUMBER,
  REP_EMPTAR       NUMBER,
  REP_IMPORTE      NUMBER,
  REP_FACTURABLE   VARCHAR2(1 BYTE)
)
NOCOMPRESS ;


CREATE TABLE DWH_CATALOGO
(
  CAT_MODID           NUMBER,
  CAT_MODELO          VARCHAR2(50 BYTE),
  CAT_CARID           NUMBER,
  CAT_CARACTERISTICA  VARCHAR2(100 BYTE),
  CAT_EXTRA           VARCHAR2(50 BYTE),
  CAT_PVP             NUMBER
)
NOCOMPRESS ;


CREATE TABLE DWH_MOVIMIENTO_COMERCIAL
(
  MCO_MODID          NUMBER,
  MCO_MODELO         VARCHAR2(50 BYTE),
  MCO_BASTIDOR       VARCHAR2(15 BYTE),
  MCO_MATRICULA      VARCHAR2(10 BYTE),
  MCO_COLOR          VARCHAR2(15 BYTE),
  MCO_FECHA          DATE,
  MCO_IMPORTE        NUMBER,
  MCO_EMPID          NUMBER,
  MCO_VENDIDO        VARCHAR2(1 BYTE),
  MCO_CONID          NUMBER,
  MCO_CONCESIONARIO  VARCHAR2(50 BYTE)
)
NOCOMPRESS ;


CREATE TABLE SIS_ERRORES
(
  CODIGO  NUMBER,
  ERROR   VARCHAR2(500 BYTE)
)
NOCOMPRESS ;


CREATE TABLE DWH_VEHICULO
(
  VEH_ID              NUMBER,
  VEH_BASTIDOR        VARCHAR2(15 BYTE),
  VEH_MATRICULA       VARCHAR2(10 BYTE),
  VEH_MODID           VARCHAR2(10 BYTE),
  VEH_MODELO          VARCHAR2(50 BYTE),
  VEH_COLOR           VARCHAR2(15 BYTE),
  VEH_FECHA           DATE,
  VEH_VENDIDO         VARCHAR2(1 BYTE),
  VEH_CONID           NUMBER,
  VEH_CONCESIONARIO   VARCHAR2(50 BYTE),
  VEH_CARACTERISTICA  VARCHAR2(100 BYTE)
)
NOCOMPRESS ;


CREATE TABLE GCU_AUDITORIA
(
  AUD_ID      NUMBER(9),
  AUD_TABLA   VARCHAR2(20 BYTE),
  AUD_ACCION  VARCHAR2(1000 BYTE),
  AUD_USRID   NUMBER(9),
  AUD_FECHA   DATE                              DEFAULT SYSDATE
)
NOCOMPRESS ;


CREATE TABLE GCU_TAREA
(
  TAR_ID          NUMBER(9),
  TAR_REPID       NUMBER(9),
  TAR_CONCEPTO    VARCHAR2(100 BYTE),
  TAR_HORAS       NUMBER(9,2),
  TAR_EMPID       NUMBER(9),
  TAR_FACTURABLE  CHAR(1 BYTE)                  DEFAULT 1,
  TAR_AUDFALTA    DATE                          DEFAULT SYSDATE,
  TAR_AUDUSRALTA  NUMBER(9),
  TAR_AUDFMOD     DATE,
  TAR_AUDUSRMOD   NUMBER(9),
  TAR_IMPORTE     NUMBER
)
NOCOMPRESS ;


CREATE TABLE GCU_REPARACION
(
  REP_ID           NUMBER(9),
  REP_FECHAINICIO  DATE,
  REP_FECHAFIN     DATE,
  REP_CLIENTE      VARCHAR2(20 BYTE),
  REP_TELEFONO     VARCHAR2(15 BYTE),
  REP_FACID        NUMBER(9),
  REP_REVISION     CHAR(1 BYTE),
  REP_VEHID        NUMBER(9),
  REP_AUDFALTA     DATE                         DEFAULT SYSDATE,
  REP_AUDUSRALTA   NUMBER(9),
  REP_AUDFMOD      DATE,
  REP_AUDUSRMOD    NUMBER(9),
  REP_EMPID        NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_LINEAFACTURA
(
  LIN_ID          NUMBER(9),
  LIN_FACID       NUMBER(9),
  LIN_CONCEPTO    VARCHAR2(100 BYTE),
  LIN_COSTE       NUMBER(15,3),
  LIN_PVP         NUMBER(15,3),
  LIN_AUDFALTA    DATE                          DEFAULT SYSDATE,
  LIN_AUDUSRALTA  NUMBER(9),
  LIN_AUDFMOD     DATE,
  LIN_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_FACTURA
(
  FAC_ID             NUMBER(9),
  FAC_CONTABILIZADA  CHAR(1 BYTE)               DEFAULT '0',
  FAC_AUDFALTA       DATE                       DEFAULT SYSDATE,
  FAC_AUDUSRALTA     NUMBER(9),
  FAC_AUDFMOD        DATE,
  FAC_AUDUSRMOD      NUMBER(9),
  FAC_FECHA          DATE
)
NOCOMPRESS ;


CREATE TABLE GCU_VENTA
(
  VEN_ID          NUMBER(9),
  VEN_VEHID       NUMBER(9),
  VEN_CLIID       NUMBER,
  VEN_FECHA       DATE,
  VEN_EMPID       NUMBER,
  VEN_FACID       NUMBER,
  VEN_AUDFALTA    DATE                          DEFAULT SYSDATE,
  VEN_AUDUSRALTA  NUMBER(9),
  VEN_AUDFMOD     DATE,
  VEN_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_CLIENTE
(
  CLI_ID          NUMBER(9),
  CLI_NOMBRE      VARCHAR2(20 BYTE),
  CLI_APELLIDO    VARCHAR2(50 BYTE),
  CLI_TELEFONO    VARCHAR2(15 BYTE),
  CLI_EMAIL       VARCHAR2(30 BYTE),
  CLI_FNAC        DATE,
  CLI_PROFESION   VARCHAR2(20 BYTE),
  CLI_AUDFALTA    DATE                          DEFAULT SYSDATE,
  CLI_AUDUSRALTA  NUMBER(9),
  CLI_AUDFMOD     DATE,
  CLI_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_CONFIGURACION
(
  CNF_VEHID       NUMBER(9),
  CNF_CARID       NUMBER(9),
  CNF_AUDFALTA    DATE                          DEFAULT SYSDATE,
  CNF_AUDUSRALTA  NUMBER(9),
  CNF_AUDFMOD     DATE,
  CNF_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_VEHICULO
(
  VEH_ID          NUMBER(9),
  VEH_BASTIDOR    VARCHAR2(15 BYTE),
  VEH_MATRICULA   VARCHAR2(10 BYTE),
  VEH_COLOR       VARCHAR2(15 BYTE),
  VEH_MODID       NUMBER(9),
  VEH_VENDIDO     CHAR(1 BYTE),
  VEH_AUDFALTA    DATE                          DEFAULT SYSDATE,
  VEH_AUDUSRALTA  NUMBER(9),
  VEH_AUDFMOD     DATE,
  VEH_AUDUSRMOD   NUMBER(9),
  VEH_CONID       NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_CARACTERISTICA
(
  CAR_ID           NUMBER(9),
  CAR_DESCRIPCION  VARCHAR2(100 BYTE),
  CAR_AUDFALTA     DATE                         DEFAULT SYSDATE,
  CAR_AUDUSRALTA   NUMBER(9),
  CAR_AUDFMOD      DATE,
  CAR_AUDUSRMOD    NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_CONCESIONARIO
(
  CON_ID          NUMBER(9),
  CON_NOMBRE      VARCHAR2(50 BYTE),
  CON_DIRECCION   VARCHAR2(100 BYTE),
  CON_TELEFONO    VARCHAR2(15 BYTE),
  CON_AUDFALTA    DATE                          DEFAULT SYSDATE,
  CON_AUDUSRALTA  NUMBER(9),
  CON_AUDFMOD     DATE,
  CON_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_MARCA
(
  MAR_ID          NUMBER(9),
  MAR_NOMBRE      VARCHAR2(20 BYTE),
  MAR_AUDFALTA    DATE                          DEFAULT SYSDATE,
  MAR_AUDUSRALTA  NUMBER(9),
  MAR_AUDFMOD     DATE,
  MAR_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_USUARIO
(
  USR_ID      NUMBER(9),
  USR_PASS    VARCHAR2(100 BYTE),
  USR_EMPID   NUMBER(9),
  USR_NOMUSR  VARCHAR2(75 BYTE)
)
NOCOMPRESS ;


CREATE TABLE GCU_MODELO
(
  MOD_ID          NUMBER(9),
  MOD_NOMBRE      VARCHAR2(50 BYTE),
  MOD_MARID       NUMBER(9),
  MOD_PVP         NUMBER(15,3),
  MOD_AUDFALTA    DATE                          DEFAULT SYSDATE,
  MOD_AUDUSRALTA  NUMBER(9),
  MOD_AUDFMOD     DATE,
  MOD_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE TABLE GCU_EMPLEADO
(
  EMP_ID          NUMBER(9),
  EMP_CONID       NUMBER(9),
  EMP_NOMBRE      VARCHAR2(25 BYTE),
  EMP_APELLIDOS   VARCHAR2(50 BYTE),
  EMP_DIRECCION   VARCHAR2(100 BYTE),
  EMP_TELEFONO    VARCHAR2(15 BYTE),
  EMP_NSS         VARCHAR2(10 BYTE),
  EMP_DNI         VARCHAR2(15 BYTE),
  EMP_SUELDO      NUMBER(15,3),
  EMP_COSTE       NUMBER(15,3),
  EMP_JEFE        CHAR(1 BYTE)                  DEFAULT 0,
  EMP_FECHAALTA   DATE,
  EMP_FECHABAJA   DATE,
  EMP_AUDFALTA    DATE                          DEFAULT SYSDATE,
  EMP_AUDUSRALTA  NUMBER(9),
  EMP_AUDFMOD     DATE,
  EMP_AUDUSRMOD   NUMBER(9),
  EMP_TIPOEMP     CHAR(1 BYTE)
)
NOCOMPRESS ;


CREATE TABLE GCU_CATALOGO
(
  CAT_ID          NUMBER(9),
  CAT_CARID       NUMBER(9),
  CAT_MODID       NUMBER(9),
  CAT_EXTRA       CHAR(1 BYTE)                  DEFAULT 0,
  CAT_PVP         NUMBER(15,3),
  CAT_AUDFALTA    DATE                          DEFAULT SYSDATE,
  CAT_AUDUSRALTA  NUMBER(9),
  CAT_AUDFMOD     DATE,
  CAT_AUDUSRMOD   NUMBER(9)
)
NOCOMPRESS ;


CREATE OR REPLACE FORCE VIEW VW_GCU_INVENTARIO
(VEH_ID, VEH_BASTIDOR, VEH_MATRICULA, VEH_COLOR, VEH_MODID, 
 VEH_VENDIDO, VEH_AUDFALTA, VEH_AUDUSRALTA, VEH_AUDFMOD, VEH_AUDUSRMOD, 
 VEH_CONID)
AS 
SELECT "VEH_ID",
          "VEH_BASTIDOR",
          "VEH_MATRICULA",
          "VEH_COLOR",
          "VEH_MODID",
          "VEH_VENDIDO",
          "VEH_AUDFALTA",
          "VEH_AUDUSRALTA",
          "VEH_AUDFMOD",
          "VEH_AUDUSRMOD",
          "VEH_CONID"
     FROM GCU_VEHICULO
    WHERE VEH_VENDIDO = '0';