--
-- Create Schema Script 
--   Database Version   : 11.2.0.2.0 
--   Toad Version       : 10.6.1.3 
--   DB Connect String  : XE 
--   Schema             : UOC 
--   Script Created by  : UOC 
--   Script Created at  : 1/14/2013 6:15:43 PM 
--   Physical Location  :  
--   Notes              :  
--

-- Object Counts: 
--   Directories: 0 
--   Triggers: 52 


CREATE OR REPLACE TRIGGER TRG_CLI_AUD
AFTER INSERT OR UPDATE
ON GCU_CLIENTE FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CLIENTE','Insercin: '||:NEW.CLI_NOMBRE||' * '||:NEW.CLI_APELLIDO||' * '||:NEW.CLI_TELEFONO||' * '||:NEW.CLI_EMAIL||' * '
        ||:NEW.CLI_FNAC||' * '||:NEW.CLI_PROFESION, :NEW.CLI_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CLIENTE','Actualizacin: '||:OLD.CLI_ID||' * '||:OLD.CLI_NOMBRE||' * '||:OLD.CLI_APELLIDO||' * '||:OLD.CLI_TELEFONO||' * '||:OLD.CLI_EMAIL||' * '
        ||:OLD.CLI_FNAC||' * '||:OLD.CLI_PROFESION||' => '||:NEW.CLI_NOMBRE||' * '||:NEW.CLI_APELLIDO||' * '||:NEW.CLI_TELEFONO||' * '
        ||:NEW.CLI_EMAIL||' * '||:NEW.CLI_FNAC||' * '||:NEW.CLI_PROFESION, :NEW.CLI_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAT_AUD
AFTER INSERT OR UPDATE
ON GCU_CATALOGO FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CATALOGO','Insercin: '||:NEW.CAT_CARID||' * '||:NEW.CAT_MODID||' * '||:NEW.CAT_EXTRA||' * '||:NEW.CAT_PVP, :NEW.CAT_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CATALOGO','Actualizacin: '||:OLD.CAT_ID||' * '||:OLD.CAT_CARID||' * '||:OLD.CAT_MODID||' * '||:OLD.CAT_EXTRA||' * '||:OLD.CAT_PVP||' => '
        ||:NEW.CAT_CARID||' * '||:NEW.CAT_MODID||' * '||:NEW.CAT_EXTRA||' * '||:NEW.CAT_PVP, :NEW.CAT_AUDUSRMOD);
    END IF;    

END;
/


CREATE OR REPLACE TRIGGER TRG_CON_AUD
AFTER INSERT OR UPDATE
ON GCU_CONCESIONARIO FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CONCESIONARIO','Insercin: '||:NEW.CON_NOMBRE||' * '||:NEW.CON_DIRECCION||' * '||:NEW.CON_TELEFONO, :NEW.CON_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CONCESIONARIO','Actualizacin: '||:OLD.CON_ID||' * '||:OLD.CON_NOMBRE||' * '||:OLD.CON_DIRECCION||' * '||:OLD.CON_TELEFONO||' => '
        ||:NEW.CON_NOMBRE||' * '||:NEW.CON_DIRECCION||' * '||:NEW.CON_TELEFONO, :NEW.CON_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_REP_PK
BEFORE INSERT
ON GCU_REPARACION FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_REP_PK.NextVal INTO :NEW.REP_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_VEH_PK
BEFORE INSERT
ON GCU_VEHICULO FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_VEH_PK.NextVal INTO :NEW.VEH_ID FROM DUAL; 
    
END;
/


CREATE OR REPLACE TRIGGER TRG_USR_PK
BEFORE INSERT
ON GCU_USUARIO FOR EACH ROW
BEGIN 
    
    SELECT SEQ_USR_PK.NextVal into :NEW.USR_ID from dual;
    SELECT FUN_ENCRIPTA(:NEW.USR_PASS) INTO :NEW.USR_PASS FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAR_PK
BEFORE INSERT 
ON GCU_CARACTERISTICA FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_CAR_PK.NextVal Into :NEW.CAR_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAT_USR
BEFORE INSERT
ON GCU_CATALOGO FOR EACH ROW
BEGIN 
    
    SELECT SEQ_CAT_PK.NextVal INTO :NEW.CAT_ID FROM DUAL; 
    :NEW.CAT_AUDUSRALTA := 1;   

END;
/


CREATE OR REPLACE TRIGGER TRG_CAT_PK
BEFORE INSERT
ON GCU_CATALOGO FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_CAT_PK.NextVal INTO :NEW.CAT_ID FROM DUAL;    

END;
/


CREATE OR REPLACE TRIGGER TRG_AUD_PK
BEFORE INSERT
ON GCU_AUDITORIA FOR EACH ROW
BEGIN 
    
   SELECT SEQ_AUD_PK.NextVal INTO :NEW.AUD_ID FROM DUAL;

END;
/


CREATE OR REPLACE TRIGGER TRG_CLI_PK
BEFORE INSERT
ON GCU_CLIENTE FOR EACH ROW
DISABLE
BEGIN 
    
   SELECT SEQ_CLI_PK.NextVal INTO :NEW.CLI_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CON_PK
BEFORE INSERT
ON GCU_CONCESIONARIO FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_CON_PK.NextVal INTO :NEW.CON_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_EMP_PK
BEFORE INSERT
ON GCU_EMPLEADO FOR EACH ROW
DISABLE
BEGIN 
    
   SELECT SEQ_EMP_PK.NextVal INTO :NEW.EMP_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_FAC_PK
BEFORE INSERT
ON GCU_FACTURA FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_FAC_PK.NextVal INTO :NEW.FAC_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_LIN_PK
BEFORE INSERT
ON GCU_LINEAFACTURA FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_LIN_PK.NextVal INTO :NEW.LIN_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MAR_PK
BEFORE INSERT
ON GCU_MARCA FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_MAR_PK.NextVal INTO :NEW.MAR_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MOD_PK
BEFORE INSERT
ON GCU_MODELO FOR EACH ROW
DISABLE
BEGIN 
  
    SELECT SEQ_MOD_PK.NextVal INTO :NEW.MOD_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_TAR_PK
BEFORE INSERT
ON GCU_TAREA FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_TAR_PK.NextVal INTO :NEW.TAR_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_VEN_PK
BEFORE INSERT
ON GCU_VENTA FOR EACH ROW
DISABLE
BEGIN 
    
    SELECT SEQ_VEN_PK.NextVal INTO :NEW.VEN_ID FROM DUAL; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAR_USR
BEFORE INSERT
ON GCU_CARACTERISTICA FOR EACH ROW
BEGIN 
    
   SELECT SEQ_CAR_PK.NextVal INTO :NEW.CAR_ID FROM DUAL; 
   :NEW.CAR_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CLI_USR
BEFORE INSERT
ON GCU_CLIENTE FOR EACH ROW
BEGIN 
    
   SELECT SEQ_CLI_PK.NextVal INTO :NEW.CLI_ID FROM DUAL; 
   :NEW.CLI_AUDUSRALTA := 1;

END;
/


CREATE OR REPLACE TRIGGER TRG_CON_USR
BEFORE INSERT
ON GCU_CONCESIONARIO FOR EACH ROW
BEGIN 
    
    SELECT SEQ_CON_PK.NextVal INTO :NEW.CON_ID FROM DUAL;
    :NEW.CON_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_EMP_USR
BEFORE INSERT
ON GCU_EMPLEADO FOR EACH ROW
BEGIN 
    
   SELECT SEQ_EMP_PK.NextVal INTO :NEW.EMP_ID FROM DUAL; 
   :NEW.EMP_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_FAC_USR
BEFORE INSERT
ON GCU_FACTURA FOR EACH ROW
BEGIN 
    
    SELECT SEQ_FAC_PK.NextVal INTO :NEW.FAC_ID FROM DUAL; 
    :NEW.FAC_AUDUSRALTA := 1;

END;
/


CREATE OR REPLACE TRIGGER TRG_LIN_USR
BEFORE INSERT
ON GCU_LINEAFACTURA FOR EACH ROW
BEGIN 
    
    SELECT SEQ_LIN_PK.NextVal INTO :NEW.LIN_ID FROM DUAL;
    :NEW.LIN_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MAR_USR
BEFORE INSERT
ON GCU_MARCA FOR EACH ROW
BEGIN 
    
    SELECT SEQ_MAR_PK.NextVal INTO :NEW.MAR_ID FROM DUAL; 
    :NEW.MAR_AUDUSRALTA := 1;

END;
/


CREATE OR REPLACE TRIGGER TRG_MOD_USR
BEFORE INSERT
ON GCU_MODELO FOR EACH ROW
BEGIN 
  
    SELECT SEQ_MOD_PK.NextVal INTO :NEW.MOD_ID FROM DUAL; 
    :NEW.MOD_AUDUSRALTA := 1;

END;
/


CREATE OR REPLACE TRIGGER TRG_REP_USR
BEFORE INSERT
ON GCU_REPARACION FOR EACH ROW
BEGIN 
    
    SELECT SEQ_REP_PK.NextVal INTO :NEW.REP_ID FROM DUAL; 
    :NEW.REP_AUDUSRALTA := 1;

END;
/


CREATE OR REPLACE TRIGGER TRG_TAR_USR
BEFORE INSERT
ON GCU_TAREA FOR EACH ROW
BEGIN 
    
    SELECT SEQ_TAR_PK.NextVal INTO :NEW.TAR_ID FROM DUAL;
    :NEW.TAR_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_VEH_USR
BEFORE INSERT
ON GCU_VEHICULO FOR EACH ROW
BEGIN 
    
    SELECT SEQ_VEH_PK.NextVal INTO :NEW.VEH_ID FROM DUAL; 
    :NEW.VEH_AUDUSRALTA := 1;
    
END;
/


CREATE OR REPLACE TRIGGER TRG_VEN_USR
BEFORE INSERT
ON GCU_VENTA FOR EACH ROW
BEGIN 
    
    SELECT SEQ_VEN_PK.NextVal INTO :NEW.VEN_ID FROM DUAL; 
    :NEW.VEN_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_EMP_AUD
AFTER INSERT OR UPDATE
ON GCU_EMPLEADO FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_EMPLEADO','Insercin: '||:NEW.EMP_CONID||' * '||:NEW.EMP_NOMBRE||' * '||:NEW.EMP_APELLIDOS||' * '||:NEW.EMP_DIRECCION||' * '||:NEW.EMP_TELEFONO
        ||' * '||:NEW.EMP_NSS||' * '||:NEW.EMP_DNI||' * '||:NEW.EMP_SUELDO||' * '||:NEW.EMP_COSTE||' * '||:NEW.EMP_JEFE||' * '||:NEW.EMP_FECHAALTA||' * '||
        :NEW.EMP_FECHABAJA||' * '||:NEW.EMP_TIPOEMP, :NEW.EMP_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_EMPLEADO','Actualizacin: '||:OLD.EMP_ID||' * '||:OLD.EMP_CONID||' * '||:OLD.EMP_NOMBRE||' * '||:OLD.EMP_APELLIDOS||' * '||:OLD.EMP_DIRECCION||' * '||:OLD.EMP_TELEFONO
        ||' * '||:OLD.EMP_NSS||' * '||:OLD.EMP_DNI||' * '||:OLD.EMP_SUELDO||' * '||:OLD.EMP_COSTE||' * '||:OLD.EMP_JEFE||' * '||:OLD.EMP_FECHAALTA||' * '||
        :OLD.EMP_FECHABAJA||' * '||:OLD.EMP_TIPOEMP||' => '||:NEW.EMP_CONID||' * '||:NEW.EMP_NOMBRE||' * '||:NEW.EMP_APELLIDOS||' * '||:NEW.EMP_DIRECCION||' * '||:NEW.EMP_TELEFONO
        ||' * '||:NEW.EMP_NSS||' * '||:NEW.EMP_DNI||' * '||:NEW.EMP_SUELDO||' * '||:NEW.EMP_COSTE||' * '||:NEW.EMP_JEFE||' * '||:NEW.EMP_FECHAALTA||' * '||
        :NEW.EMP_FECHABAJA||' * '||:NEW.EMP_TIPOEMP, :NEW.EMP_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_REP_AUD
AFTER INSERT OR UPDATE
ON GCU_REPARACION FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_REPARACION','Insercin: '||:NEW.REP_FECHAINICIO||' * '||:NEW.REP_FECHAFIN||' * '||:NEW.REP_CLIENTE||' * '||:NEW.REP_TELEFONO||' * '||
        :NEW.REP_FACID||' * '||:NEW.REP_REVISION||' * '||:NEW.REP_VEHID||' * '||:NEW.REP_EMPID,:NEW.REP_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_REPARACION','Actualizacin: '||:OLD.REP_FECHAINICIO||' * '||:OLD.REP_FECHAFIN||' * '||:OLD.REP_CLIENTE||' * '||:OLD.REP_TELEFONO||' * '||
        :OLD.REP_FACID||' * '||:OLD.REP_REVISION||' * '||:OLD.REP_VEHID||' * '||:OLD.REP_EMPID||' => '||:NEW.REP_FECHAINICIO||' * '||:NEW.REP_FECHAFIN
        ||' * '||:NEW.REP_CLIENTE||' * '||:NEW.REP_TELEFONO||' * '||:NEW.REP_FACID||' * '||:NEW.REP_REVISION||' * '||:NEW.REP_VEHID||' * '||:NEW.REP_EMPID, 
        :NEW.REP_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_FAC_AUD
AFTER INSERT OR UPDATE
ON GCU_FACTURA FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_FACTURA','Insercin: '||:NEW.FAC_ID||' * '||:NEW.FAC_CONTABILIZADA, :NEW.FAC_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_FACTURA','Actualizacin: '||:OLD.FAC_ID||' * '||:OLD.FAC_CONTABILIZADA||' => '||:NEW.FAC_ID||' * '||:NEW.FAC_CONTABILIZADA, :NEW.FAC_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_LIN_AUD
AFTER INSERT OR UPDATE
ON GCU_LINEAFACTURA FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_LINEAFACTURA','Insercin: '||:NEW.LIN_FACID||' * '||:NEW.LIN_ID||' * '||:NEW.LIN_CONCEPTO||' * '||:NEW.LIN_COSTE||' * '||:NEW.LIN_PVP, 
        :NEW.LIN_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_LINEAFACTURA','Actualizacin: '||:OLD.LIN_FACID||' * '||:OLD.LIN_ID||' * '||:OLD.LIN_CONCEPTO||' * '||:OLD.LIN_COSTE||' * '||:OLD.LIN_PVP
        ||' => '||:NEW.LIN_FACID||' * '||:NEW.LIN_ID||' * '||:NEW.LIN_CONCEPTO||' * '||:NEW.LIN_COSTE||' * '||:NEW.LIN_PVP, :NEW.LIN_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MAR_AUD
AFTER INSERT OR UPDATE
ON GCU_MARCA FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_MARCA','Insercin: '||:NEW.MAR_NOMBRE,:NEW.MAR_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_MARCA','Actualizacin: '||:OLD.MAR_ID||' * '||:OLD.MAR_NOMBRE ||' => '||:NEW.MAR_ID||' * '||:NEW.MAR_NOMBRE, :NEW.MAR_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MOD_AUD
AFTER INSERT OR UPDATE
ON GCU_MODELO FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_MODELO','Insercin: '||:NEW.MOD_NOMBRE||' * '||:NEW.MOD_MARID||' * '||:NEW.MOD_PVP,:NEW.MOD_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_MODELO','Actualizacin: '||:OLD.MOD_MARID||:OLD.MOD_NOMBRE||' * '||:OLD.MOD_MARID||' * '||:OLD.MOD_PVP||' => '
        ||:NEW.MOD_NOMBRE||' * '||:NEW.MOD_MARID||' * '||:NEW.MOD_PVP, :NEW.MOD_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_TAR_AUD
AFTER INSERT OR UPDATE
ON GCU_TAREA FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_Tarea','Insercin: '||:NEW.TAR_REPID||' * '||:NEW.TAR_CONCEPTO||' * '||:NEW.TAR_HORAS||' * '||:NEW.TAR_EMPID||' * '||
        :NEW.TAR_FACTURABLE,:NEW.TAR_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_Tarea','Actualizacin: '||:OLD.TAR_ID||' * '||:OLD.TAR_REPID||' * '||:OLD.TAR_CONCEPTO||' * '||:OLD.TAR_HORAS||' * '||:OLD.TAR_EMPID||' * '||
        :OLD.TAR_FACTURABLE||' => '||:NEW.TAR_REPID||' * '||:NEW.TAR_CONCEPTO||' * '||:NEW.TAR_HORAS||' * '||:NEW.TAR_EMPID||' * '||:NEW.TAR_FACTURABLE, 
        :NEW.TAR_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_VEH_AUD
AFTER INSERT OR UPDATE
ON GCU_VEHICULO FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_VEHICULO','Insercin: '||:NEW.VEH_BASTIDOR||' * '||:NEW.VEH_MATRICULA||' * '||:NEW.VEH_COLOR||' * '||:NEW.VEH_MODID||' * '||:NEW.VEH_VENDIDO
        ||' * '||:NEW.VEH_CONID,:NEW.VEH_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_VEHICULO','Actualizacin: '||:OLD.VEH_ID||' * '||:OLD.VEH_BASTIDOR||' * '||:OLD.VEH_MATRICULA||' * '||:OLD.VEH_COLOR||' * '||:OLD.VEH_MODID
        ||' * '||:OLD.VEH_VENDIDO ||' * '||:OLD.VEH_CONID||' => '||:NEW.VEH_BASTIDOR||' * '||:NEW.VEH_MATRICULA||' * '||:NEW.VEH_COLOR||' * '||:NEW.VEH_MODID
        ||' * '||:NEW.VEH_VENDIDO ||' * '||:NEW.VEH_CONID, :NEW.VEH_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CLI_MOD
BEFORE UPDATE OR DELETE
ON GCU_CLIENTE FOR EACH ROW
BEGIN 
    
    IF UPDATING THEN
        :NEW.CLI_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CLIENTE','Eliminacin: '||:OLD.CLI_NOMBRE||' * '||:OLD.CLI_APELLIDO, :NEW.CLI_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_VEN_AUD
AFTER INSERT OR UPDATE
ON GCU_VENTA FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_VENTA','Insercin: '||:NEW.VEN_VEHID||' * '||:NEW.VEN_CLIID||' * '||:NEW.VEN_FECHA||' * '||:NEW.VEN_EMPID||' * '||:NEW.VEN_FACID,:NEW.VEN_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_VENTA','Actualizacin: '||:OLD.VEN_ID|| '* '||:NEW.VEN_VEHID||' * '||:NEW.VEN_CLIID||' * '||:NEW.VEN_FECHA||' * '||:NEW.VEN_EMPID||' * '||
        :NEW.VEN_FACID||' => '||:NEW.VEN_CLIID||' * '||:NEW.VEN_FECHA||' * '||:NEW.VEN_EMPID||' * '||:NEW.VEN_FACID, :NEW.VEN_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAR_AUD
AFTER INSERT OR UPDATE
ON GCU_CARACTERISTICA FOR EACH ROW
BEGIN 
    
   IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CARACTERISTICA','Insercin: '||:NEW.CAR_DESCRIPCION, :NEW.CAR_AUDUSRALTA);
   ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CARACTERISTICA','Actualizacin: '||:OLD.CAR_ID||' * '||:OLD.CAR_DESCRIPCION||' => '||:NEW.CAR_DESCRIPCION, :NEW.CAR_AUDUSRMOD);
        
   END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAR_MOD
BEFORE UPDATE OR DELETE
ON GCU_CARACTERISTICA FOR EACH ROW
BEGIN 
    
   IF UPDATING THEN
       :NEW.CAR_AUDFMOD := SYSDATE; 
   ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CARACTERISTICA','Eliminacin: '||:OLD.CAR_ID||' * '||:OLD.CAR_DESCRIPCION, :OLD.CAR_AUDUSRMOD);
        
   END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CAT_MOD
BEFORE UPDATE OR DELETE
ON GCU_CATALOGO FOR EACH ROW
BEGIN 
    
   IF UPDATING THEN
       :NEW.CAT_AUDFMOD := SYSDATE; 
   ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CATALOGO','Eliminacin: '||:OLD.CAT_ID||' * '||:OLD.CAT_CARID||' * '||:OLD.CAT_MODID, :OLD.CAT_AUDUSRMOD);
        
   END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CON_MOD
BEFORE UPDATE OR DELETE
ON GCU_CONCESIONARIO FOR EACH ROW
BEGIN 
    
    IF UPDATING THEN
        :NEW.CON_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CONCESIONARIO','Eliminacin: '||:OLD.CON_NOMBRE, :OLD.CON_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_EMP_MOD
BEFORE UPDATE OR DELETE
ON GCU_EMPLEADO FOR EACH ROW
BEGIN 
    
    IF UPDATING THEN
        :NEW.EMP_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_EMPLEADO','Eliminacin: '||:OLD.EMP_NOMBRE, :NEW.EMP_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MOD_MOD
BEFORE UPDATE OR DELETE
ON GCU_MODELO FOR EACH ROW
BEGIN 
    
    IF UPDATING THEN
        :NEW.MOD_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_MODELO','Eliminacin: '||:OLD.MOD_NOMBRE, :NEW.MOD_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_MAR_MOD
BEFORE UPDATE OR DELETE
ON GCU_MARCA FOR EACH ROW
BEGIN 
    
    IF UPDATING THEN
        :NEW.MAR_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_MARCA','Eliminacin: '||:OLD.MAR_NOMBRE, :NEW.MAR_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CNF_USR
BEFORE INSERT
ON GCU_CONFIGURACION FOR EACH ROW
BEGIN 
    
    :NEW.CNF_AUDUSRALTA := 1; 

END;
/


CREATE OR REPLACE TRIGGER TRG_VEH_MOD
BEFORE UPDATE OR DELETE
ON GCU_VEHICULO FOR EACH ROW
BEGIN 
    
   IF UPDATING THEN
        :NEW.VEH_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_VEHICULO','Eliminacin: '||:OLD.VEH_ID||' * '||:OLD.VEH_BASTIDOR||' * '||:OLD.VEH_MATRICULA, :NEW.VEH_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CNF_AUD
AFTER INSERT OR UPDATE
ON GCU_CONFIGURACION FOR EACH ROW
BEGIN 
    
    IF INSERTING THEN
        INSERT INTO GCU_AUDITORIA 
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CONFIGURACION','Insercin: '||:NEW.CNF_VEHID||' * '||:NEW.CNF_CARID, :NEW.CNF_AUDUSRALTA);
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CONFIGURACION','Actualizacin: '||:OLD.CNF_VEHID||' * '||:OLD.CNF_CARID||' => '||:NEW.CNF_VEHID||' * '||:NEW.CNF_CARID, :NEW.CNF_AUDUSRMOD);
    END IF; 

END;
/


CREATE OR REPLACE TRIGGER TRG_CNF_MOD
BEFORE UPDATE OR DELETE
ON GCU_CONFIGURACION FOR EACH ROW
BEGIN 
    
    IF UPDATING THEN
        :NEW.CNF_AUDFMOD := SYSDATE;
    ELSE
        INSERT INTO GCU_AUDITORIA
        (AUD_TABLA, AUD_ACCION, AUD_USRID)
        VALUES
        ('GCU_CONFIGURACION','Eliminacin: '||:OLD.CNF_VEHID||' * '||:OLD.CNF_CARID, :OLD.CNF_AUDUSRMOD);
    END IF; 

END;
/