--
-- Create Schema Script 
--   Database Version   : 11.2.0.2.0 
--   Toad Version       : 10.6.1.3 
--   DB Connect String  : XE 
--   Schema             : UOC 
--   Script Created by  : UOC 
--   Script Created at  : 1/14/2013 9:27:32 PM 
--   Physical Location  :  
--   Notes              :  
--

-- Object Counts: 
--   Directories: 0 
--   Packages: 6        Lines of Code: 279 
--   Package Bodies: 6  Lines of Code: 1117 


CREATE OR REPLACE package     PKG_GCU_MAESTROS IS

--
--Este package gestiona los datos de los maestros: 
-- Concesionarios
-- Marcas
-- Modelos
-- Caractersticas
-- Catlogo
-- Empleados
--

--
-- GESTIN DE CONCESIONARIOS
--
Procedure Crea_Concesionario(
p_NOMBRE in varchar2, 
p_DIRECCION In Varchar2, 
p_TELEFONO In Varchar2, 
p_USERID In Number);

Procedure Modifica_Concesionario(
p_CONID In Number, 
p_NOMBRE In varchar2, 
p_DIRECCION In Varchar2, 
p_TELEFONO In Varchar2, 
p_USERID In Number);

Procedure Elimina_Concesionario (
p_CONID In Number,
p_USERID In Number); 

--
-- GESTIN DE MARCAS
--
Procedure Crea_Marca(
p_NOMBRE in varchar2, 
p_USERID In Number);

Procedure Modifica_Marca(
p_MARID In Number, 
p_NOMBRE In varchar2,  
p_USERID In Number);

Procedure Elimina_Marca (
p_MARID In Number,
p_USERID In Number);

--
-- GESTIN DE MODELOS
--
Procedure Crea_Modelo(
p_NOMBRE in varchar2, 
p_MARID In Varchar2, 
p_PVP In Varchar2, 
p_USERID In Number);

Procedure Modifica_Modelo(
p_MODID In Number, 
p_NOMBRE In Varchar2,
p_MARID In Varchar2, 
p_PVP In Varchar2, 
p_USERID In Number);

Procedure Elimina_Modelo (
p_MODID In Number,
p_USERID In Number);

--
-- GESTIN DE CARACTERSTICAS
--

Procedure Crea_Caracterisica(
p_DESCRIPCION in varchar2, 
p_USERID In Number);

Procedure Modifica_Caracteristica(
p_DESCRIPCION In Varchar2, 
p_CARID In Number,
p_USERID In Number);

Procedure Elimina_Caracteristica (
p_CARID In Number,
p_USERID In Number);

--
-- GESTIN DE CATLOGO
--

Procedure Crea_Catalogo(
p_CARID In number, 
p_MODID In Number, 
p_EXTRA In Char, 
p_PVP IN Number,
p_DESCRIPCION in varchar2, 
p_USERID In Number);

Procedure Modifica_Catalogo(
p_CATID In Number, 
p_CARID In Number,
p_MODID In Number,
p_EXTRA In Char,
p_PVP In Number,
p_USERID In Number);

Procedure Elimina_Catalogo (
p_CATID In Number,
p_USERID In Number);

--
-- GESTIN DE EMPLEADOS
--

Procedure Crea_Empleado(
p_CONID In number, 
p_NOMBRE In Varchar2, 
p_APELLIDOS In Varchar2, 
p_DIRECCION IN Varchar2,
p_TELEFONO in Varchar2, 
p_NSS In Varchar2,
p_DNI In Varchar2,
p_SUELDO In Number,
p_COSTE In Number,
p_JEFE In Char,
p_FECHAALTA In Date,
p_TIPOEMP In Char,
p_USERID In Number);

Procedure Modifica_Empleado(
p_EMPID In Number, 
p_CONID In number, 
p_NOMBRE In Varchar2, 
p_APELLIDOS In Varchar2, 
p_DIRECCION IN Varchar2,
p_TELEFONO in Varchar2, 
p_NSS In Varchar2,
p_DNI In Varchar2,
p_SUELDO In Number,
p_COSTE In Number,
p_JEFE In Char,
p_FECHAALTA In Date,
p_FECHABAJA In Date,
p_TIPOEMP In Char,
p_USERID In Number);

Procedure Elimina_Empleado (
p_EMPID In Number,
p_USERID In Number);

END PKG_GCU_MAESTROS;
/


CREATE OR REPLACE package     PKG_GCU_VEHICULO IS

Procedure Crea_Vehiculo(
p_BASTIDOR In Varchar2, 
p_MATRICULA In Varchar2,
p_COLOR In Varchar2, 
p_MODID IN Number,
p_USERID In Number);

Procedure Modifica_Vehiculo(
p_VEHID In Number, 
p_BASTIDOR In Varchar2,
p_MATRICULA In Varchar2,
p_COLOR In Varchar2,
p_MODID In Number,
p_USERID In Number);

Procedure Elimina_Vehiculo (
p_VEHID In Number,
p_USERID In Number);

Procedure Vehiculo_Vendido (
p_VEHID In Number,
p_VENDIDO In Char,
p_USERID In Number);

--
--CONFIGURACIN DEL VEHCULO. Funciones para configurar el vehculo, aadir o eliminar caracterstica. 
--

Procedure Add_Caracteristica (
p_VEHID In Number,
p_CARID In Number,
p_USERID In Number);

Procedure Delete_Caracteristica (
p_VEHID In Number,
p_CARID In Number,
p_USERID In Number);

END PKG_GCU_VEHICULO;
/


CREATE OR REPLACE package     PKG_DWH_CARGA IS

-- 
-- CARGA DATA WAREHOUSE
-- 

Procedure Carga; 

END PKG_DWH_CARGA;
/


CREATE OR REPLACE package     PKG_GCU_FACTURACION IS

TYPE cursor_type IS REF CURSOR;
-- 
-- GENERACIN FACTURAS
-- 
Procedure Facturar_Venta( 
p_VENID In Number, 
p_VEHID In Number,
p_USERID In Number, 
p_FACID Out Number);

Procedure Facturar_Reparacion( 
p_REPID In Number, 
p_USERID In Number, 
p_FACID Out Number);

/*Procedure Datos_Factura_Venta(
p_FACID In Number,
p_DATFAC Out SYS_REFCURSOR);*/

END PKG_GCU_FACTURACION;
/


CREATE OR REPLACE package     PKG_GCU_TALLER IS

-- 
-- GESTIN TALLER
-- 
Procedure Nueva_Reparacion(
p_CLIENTE In Varchar2,
p_TELEFONO In Varchar2, 
p_REVISION In Varchar2,
p_VEHID In Number, 
p_EMPID In Number,
p_CLIId In Number,
p_USERID In Number, 
p_REPID Out Number);

Procedure Nueva_Tarea(
p_REPID In Number,
p_CONCEPTO In Varchar2,
p_HORAS In Number,
p_EMPID In Number,
p_FACTURABLE In Varchar2,
p_IMPORTE In Number,
p_USERID In Number,
p_TARID Out Number);

Procedure Modifica_Tarea(
p_REPID In Number,
p_TARID In Number,
p_CONCEPTO In Varchar2,
p_HORAS In Number,
p_EMPID In Number,
p_FACTURABLE In Varchar2,
p_IMPORTE In Number,
p_USERID In Number);

Procedure Elimina_Tarea(
p_REPID In Number,
p_TARID In Number,
p_USERID In Number);

Procedure Cierra_Reparacion (
p_REPID In Number, 
p_USERID In Number);

END PKG_GCU_TALLER;
/


CREATE OR REPLACE package     PKG_GCU_COMERCIAL IS

-- 
-- VENTA DE VEHCULOS
-- 
Procedure Nueva_Venta(
p_VEHID In Number, 
p_EMPID In Number,
p_CLIID In Varchar2, 
p_USERID In Number);

END PKG_GCU_COMERCIAL;
/


CREATE OR REPLACE package body     PKG_GCU_MAESTROS IS

Procedure Crea_Concesionario(
p_NOMBRE in varchar2, 
p_DIRECCION In Varchar2, 
p_TELEFONO In Varchar2, 
p_USERID In Number)Is
--
-- Crea un nuevo concesionario. . 
--


Begin 

    Insert into GCU_CONCESIONARIO
    (CON_NOMBRE, CON_DIRECCION, CON_TELEFONO, CON_AUDUSRALTA)
    VALUES
    (p_NOMBRE, p_DIRECCION, p_TELEFONO, p_USERID); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al crear concesionario: '||p_NOMBRE);
    

end Crea_Concesionario;

Procedure Modifica_Concesionario(
p_CONID In Number, 
p_NOMBRE In varchar2, 
p_DIRECCION In Varchar2, 
p_TELEFONO In Varchar2, 
p_USERID In Number)Is
--
-- Modifica los datos de un concesionario
--
Begin 

    Update GCU_CONCESIONARIO
    Set CON_NOMBRE = p_NOMBRE,
        CON_DIRECCION = p_DIRECCION, 
        CON_TELEFONO = p_TELEFONO,
        CON_AUDUSRMOD = p_USERID
    Where CON_ID = p_CONID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20002, 'Error al modificar el concesionario: '||p_CONID);
     
End Modifica_Concesionario; 

Procedure Elimina_Concesionario (
p_CONID In Number,
p_USERID In Number)Is 
--
-- Elimina un concesionario
--
Begin
-- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_CONCESIONARIO
    SET CON_AUDUSRMOD = p_USERID
    WHERE CON_ID =p_CONID; 

    DELETE GCU_CONCESIONARIO
    WHERE CON_ID =p_CONID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20003, 'Error al eliminar el concesionario: '||p_CONID);

End Elimina_Concesionario;

Procedure Crea_Marca(
p_NOMBRE in varchar2, 
p_USERID In Number)Is
--
-- Crea una nueva marca. . 
--
Begin 

    Insert into GCU_MARCA
    (MAR_NOMBRE, MAR_AUDUSRALTA)
    VALUES
    (p_NOMBRE, p_USERID); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20004, 'Error al crear la marca: '||p_NOMBRE);

end Crea_Marca;

Procedure Modifica_Marca(
p_MARID In Number, 
p_NOMBRE In varchar2,  
p_USERID In Number)Is
--
-- Modifica el nombre de una marca
--
Begin 

    Update GCU_MARCA
    Set MAR_NOMBRE = p_NOMBRE,
    MAR_AUDUSRMOD = p_USERID
    Where MAR_ID = p_MARID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20005, 'Error al modificar la marca: '||p_MARID);
     
End Modifica_Marca; 

Procedure Elimina_Marca (
p_MARID In Number,
p_USERID In Number)Is 
--
-- Elimina un concesionario
--
Begin

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_MARCA
    SET MAR_AUDUSRMOD = p_USERID
    WHERE MAR_ID = p_MARID; 
    
    DELETE GCU_MARCA
    WHERE MAR_ID =p_MARID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20006, 'Error al eliminar la marca: '||p_MARID);

End Elimina_Marca;
 
Procedure Crea_Modelo(
p_NOMBRE in varchar2, 
p_MARID In Varchar2, 
p_PVP In Varchar2, 
p_USERID In Number)Is
--
-- Crea un nuevo modelo. . 
--
Begin 

    Insert into GCU_MODELO
    (MOD_NOMBRE, MOD_MARID, MOD_PVP, MOD_AUDUSRALTA)
    VALUES
    (p_NOMBRE, p_MARID, p_PVP, p_USERID); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20007, 'Error al crear modelo: '||p_NOMBRE);
    

end Crea_Modelo;

Procedure Modifica_Modelo(
p_MODID In Number, 
p_NOMBRE In Varchar2,
p_MARID In Varchar2, 
p_PVP In Varchar2, 
p_USERID In Number)Is
--
-- Modifica los datos de un modelo
--
Begin 

    Update GCU_MODELO
    Set MOD_MARID = p_MARID,
        MOD_PVP = p_PVP, 
        MOD_NOMBRE = p_NOMBRE,
        MOD_AUDUSRMOD = p_USERID
    Where MOD_ID = p_MODID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20008, 'Error al modificar el modelo: '||p_MODID);
     
End Modifica_Modelo; 

Procedure Elimina_Modelo (
p_MODID In Number,
p_USERID In Number)Is 
--
-- Elimina un modelo
--
Begin

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_MODELO
    SET MOD_AUDUSRMOD = p_USERID
    WHERE MOD_ID =p_MODID;  
    
    DELETE GCU_MODELO
    WHERE MOD_ID =p_MODID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20009, 'Error al eliminar el modelo: '||p_MODID);

End Elimina_Modelo;


Procedure Crea_Caracterisica(
p_DESCRIPCION in varchar2, 
p_USERID In Number)Is
--
-- Crea una nueva Caracterstica. . 
--
Begin 

    Insert into GCU_CARACTERISTICA
    (CAR_DESCRIPCION, CAR_AUDUSRALTA)
    VALUES
    (p_DESCRIPCION, p_USERID); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20010, 'Error al crear caracterstica: '||p_DESCRIPCION);
    

end Crea_Caracterisica;

Procedure Modifica_Caracteristica(
p_DESCRIPCION In Varchar2, 
p_CARID In Number,
p_USERID In Number)Is
--
-- Modifica los datos de un modelo
--
Begin 

    Update GCU_CARACTERISTICA
    Set CAR_DESCRIPCION = p_DESCRIPCION,
        CAR_AUDUSRMOD = p_USERID
    Where CAR_ID = p_CARID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20011, 'Error al modificar el caracterstica: '||p_DESCRIPCION);
     
End Modifica_Caracteristica; 

Procedure Elimina_Caracteristica (
p_CARID In Number,
p_USERID In Number)Is 
--
-- Elimina un modelo
--
Begin

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_CARACTERISTICA
    SET CAR_AUDUSRMOD = p_USERID
    WHERE CAR_ID = p_CARID; 

    DELETE GCU_CARACTERISTICA
    WHERE CAR_ID =p_CARID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20012, 'Error al eliminar la caracteristica: '||p_CARID);

End Elimina_Caracteristica;

Procedure Crea_Catalogo(
p_CARID In number, 
p_MODID In Number, 
p_EXTRA In Char, 
p_PVP IN Number,
p_DESCRIPCION in varchar2, 
p_USERID In Number)Is
--
-- Crea una nueva Caracterstica. . 
--
Begin 

    Insert into GCU_CATALOGO
    (CAT_CARID, CAT_MODID, CAT_EXTRA, CAT_PVP, CAT_AUDUSRALTA)
    VALUES
    (p_CARID, p_MODID, p_EXTRA, p_PVP, p_USERID); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20013, 'Error al crear catlogo: '||p_CARID||' * '||p_MODID);
    

end Crea_Catalogo;

Procedure Modifica_Catalogo(
p_CATID In Number, 
p_CARID In Number,
p_MODID In Number,
p_EXTRA In Char,
p_PVP In Number,
p_USERID In Number)Is
--
-- Modifica los datos de un modelo
--
Begin 

    Update GCU_CATALOGO
    Set CAT_CARID = p_CARID,
        CAT_MODID = p_MODID,
        CAT_EXTRA = p_EXTRA,
        CAT_PVP = p_PVP,
        CAT_AUDUSRMOD = p_USERID
    Where CAT_ID = p_CATID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20014, 'Error al modificar el catlogo: '||p_CATID);
     
End Modifica_Catalogo; 

Procedure Elimina_Catalogo (
p_CATID In Number,
p_USERID In Number)Is 
--
-- Elimina un modelo
--
Begin

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_CATALOGO
    SET CAT_AUDUSRMOD = p_USERID
    WHERE CAT_ID = p_CATID; 

    DELETE GCU_CATALOGO
    WHERE CAT_ID =p_CATID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20015, 'Error al eliminar el catlogo: '||p_CATID);

End Elimina_Catalogo;

Procedure Crea_Empleado(
p_CONID In number, 
p_NOMBRE In Varchar2, 
p_APELLIDOS In Varchar2, 
p_DIRECCION IN Varchar2,
p_TELEFONO in Varchar2, 
p_NSS In Varchar2,
p_DNI In Varchar2,
p_SUELDO In Number,
p_COSTE In Number,
p_JEFE In Char,
p_FECHAALTA In Date,
p_TIPOEMP In Char,
p_USERID In Number)Is
--
-- Crea un nuevo empleado y su usuario
--
v_EMPID GCU_EMPLEADO.EMP_ID%Type;

Begin 

    Insert into GCU_EMPLEADO
    (EMP_CONID, EMP_NOMBRE, EMP_APELLIDOS, EMP_DIRECCION, EMP_TELEFONO, EMP_NSS,EMP_DNI,
    EMP_SUELDO, EMP_COSTE, EMP_JEFE, EMP_FECHAALTA, EMP_TIPOEMP, EMP_AUDUSRALTA)
    VALUES
    (p_CONID, p_NOMBRE, p_APELLIDOS, p_DIRECCION, p_TELEFONO, p_NSS, p_DNI,
    p_SUELDO, p_COSTE, p_JEFE, p_FECHAALTA, p_TIPOEMP, p_USERID) 
    RETURNING EMP_ID Into v_EMPID; 
    
    --
    -- Creamos el usuario del empleado
    --   
    Insert into GCU_USUARIO 
    (USR_PASS, USR_EMPID, USR_NOMUSR)
    Values
    (p_DNI, v_EMPID, p_NOMBRE||' '||p_APELLIDOS); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20016, 'Error al crear empleado: '||p_NOMBRE||' * '||p_APELLIDOS);
    

end Crea_Empleado;

Procedure Modifica_Empleado(
p_EMPID In Number, 
p_CONID In number, 
p_NOMBRE In Varchar2, 
p_APELLIDOS In Varchar2, 
p_DIRECCION IN Varchar2,
p_TELEFONO in Varchar2, 
p_NSS In Varchar2,
p_DNI In Varchar2,
p_SUELDO In Number,
p_COSTE In Number,
p_JEFE In Char,
p_FECHAALTA In Date,
p_FECHABAJA In Date,
p_TIPOEMP In Char,
p_USERID In Number)Is
--
-- Modifica los datos de un empleado
--
Begin 

    Update GCU_EMPLEADO
    Set EMP_CONID = p_CONID,
        EMP_NOMBRE = p_NOMBRE, 
        EMP_APELLIDOS = p_APELLIDOS,
        EMP_DIRECCION = p_DIRECCION,
        EMP_TELEFONO = p_TELEFONO,
        EMP_NSS = p_NSS,
        EMP_DNI = p_DNI,
        EMP_SUELDO = p_SUELDO,
        EMP_COSTE = p_COSTE,
        EMP_JEFE = p_JEFE,
        EMP_FECHAALTA = p_FECHAALTA,
        EMP_FECHABAJA = p_FECHABAJA,
        EMP_TIPOEMP = p_TIPOEMP,
        EMP_AUDUSRMOD = p_USERID
    Where EMP_ID = p_EMPID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20017, 'Error al modificar el empleado: '||p_EMPID);
     
End Modifica_Empleado; 

Procedure Elimina_Empleado (
p_EMPID In Number,
p_USERID In Number)Is 
--
-- Elimina un empleado
--
Begin

    -- 
    -- Actualizamos la fecha de baja del empleado 
    -- 
    UPDATE GCU_EMPLEADO
    SET EMP_FECHABAJA = Sysdate, 
    EMP_AUDUSRMOD = p_USERID
    WHERE EMP_ID = p_EMPID; 

    DELETE GCU_EMPLEADO
    WHERE EMP_ID =p_EMPID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20018, 'Error al eliminar el empleado: '||p_EMPID);

End Elimina_Empleado;
      
END PKG_GCU_MAESTROS;
/


CREATE OR REPLACE package body     PKG_GCU_VEHICULO IS

Procedure Crea_Vehiculo(
p_BASTIDOR In Varchar2, 
p_MATRICULA In Varchar2,
p_COLOR In Varchar2, 
p_MODID IN Number,
p_USERID In Number)Is
--
-- Crea un nuevo vehculo. Si el usuario que crea un vehculo es un mecnico, entonces el vehiculo
-- se ha creado para hacer una reparacin. En caso contrario se trata de un vehculo nuevo o seminuevo.   
--

v_CONID GCU_VEHICULO.VEH_CONID%Type;

v_VENDIDO GCU_VEHICULO.VEH_VENDIDO%Type; 

Begin 

    --
    -- Obtenemos el concesionario del usuario. 
    --
    v_CONID := FUN_GET_CONID_BY_USER(p_USERID); 
    
    --
    -- Si el usuario es un mecnico, est creando el coche para registrarlo en una reparacin, por tanto
    -- el vehculo est vendido.Si el usuario es un comercial, el coche es nuevo o seminuevo. 
    --
    If FUN_GET_TIPEMP_BY_USER(p_USERID) = 'M' Then
    
        v_VENDIDO := '1';
    
    Else v_VENDIDO := '0';
    
    End If;    

    Insert into GCU_VEHICULO
    (VEH_BASTIDOR, VEH_MATRICULA, VEH_COLOR, VEH_MODID, VEH_CONID, VEH_VENDIDO, VEH_AUDUSRALTA)
    VALUES
    (p_BASTIDOR, p_MATRICULA, p_COLOR, p_MODID, v_CONID, v_VENDIDO, p_USERID); 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20023, 'Error al crear vehiculo: '||p_BASTIDOR);

end Crea_Vehiculo;

Procedure Modifica_Vehiculo(
p_VEHID In Number, 
p_BASTIDOR In Varchar2,
p_MATRICULA In Varchar2,
p_COLOR In Varchar2,
p_MODID In Number,
p_USERID In Number)Is
--
-- Modifica los datos de un vehculo
--
Begin 

    Update GCU_VEHICULO
    Set VEH_BASTIDOR = p_BASTIDOR,
        VEH_MATRICULA = p_MATRICULA,
        VEH_COLOR = p_COLOR,
        VEH_MODID = p_MODID,
        VEH_AUDUSRMOD = p_USERID
    Where VEH_ID = p_VEHID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20024, 'Error al modificar el vehculo: '||p_VEHID);
     
End Modifica_Vehiculo; 

Procedure Elimina_Vehiculo (
p_VEHID In Number,
p_USERID In Number)Is 
--
-- Elimina un vehculo
--
Begin

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_VEHICULO
    SET VEH_AUDUSRMOD = p_USERID
    WHERE VEH_ID = p_VEHID; 

    DELETE GCU_VEHICULO
    WHERE VEH_ID =p_VEHID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20025, 'Error al eliminar el vehculo: '||p_VEHID);

End Elimina_Vehiculo;

Procedure Vehiculo_Vendido (
p_VEHID In Number,
p_VENDIDO In Char,
p_USERID In Number)Is 
--
-- Marca un vehculo como vendido. 
--
Begin

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 
    UPDATE GCU_VEHICULO
    SET VEH_VENDIDO = p_VENDIDO,
        VEH_AUDUSRMOD = p_USERID
    WHERE VEH_ID = p_VEHID; 
    
Exception WHEN OTHERS THEN
    raise_application_error (-20026, 'Error al marcar el vehculo como vendido: '||p_VEHID);

End Vehiculo_Vendido;

Procedure Add_Caracteristica (
p_VEHID In Number,
p_CARID In Number,
p_USERID In Number) Is
--
-- Aade una caracterstica extra a un vehiculo. 
-- A partir del modelo del vehculo validamos si la caracterstica que deseamos aadir es vlida. 
-- Entendemos por caracterstica vlida aquella que est contemplada en el catalgo como caracterstica extra 
-- y que est disponible para el modelo del vehculo.   
--

Cursor c_CAR_VALIDA Is
Select 'S' 
FROM GCU_CATALOGO
JOIN GCU_MODELO ON CAT_MODID = MOD_ID
JOIN GCU_VEHICULO ON MOD_ID = VEH_MODID
Where VEH_ID = p_VEHID
AND CAT_CARID = p_CARID
AND CAT_EXTRA = '1';

v_CAR_VALIDA c_CAR_VALIDA%RowType;

Cursor c_CNF_VALIDA Is
Select 'S'
FROM GCU_CONFIGURACION
Where CNF_VEHID = p_VEHID
And CNF_CARID = p_CARID; 

v_CNF_VALIDA c_CNF_VALIDA%RowType;

Begin

    --
    -- Validamos si la caracterstica es vlida
    --
    Open c_CAR_VALIDA; 
    Fetch c_CAR_VALIDA Into v_CAR_VALIDA;
    If c_CAR_VALIDA%Found Then
    
        --
        -- Comprueba que la caracterstica no exista
        --
        Open c_CNF_VALIDA;
        Fetch c_CNF_VALIDA Into v_CNF_VALIDA;
        If c_CNF_VALIDA%NotFound Then
        
            --
            -- Aade la caracterstica a la configuracin del vehculo
            --
            Insert into GCU_CONFIGURACION
            (CNF_VEHID, CNF_CARID, CNF_AUDUSRALTA)
            Values
            (p_VEHID, p_CARID, p_USERID);
        Else
            raise_application_error (-20027, 'Caracterstica repetida:' ||p_CARID||' * '||p_VEHID);
        End If;  
        
    Else
        raise_application_error (-20028, 'Caracterstica no vlida');
    End if; 
    
End Add_Caracteristica;

Procedure Delete_Caracteristica (
p_VEHID In Number,
p_CARID In Number,
p_USERID In Number) Is
--
-- Elimina la Caracterstica
--
Begin 

    -- 
    -- Guardamos el usuario de modificacin para guardarlo posteriormente en la auditora. 
    -- 

    UPDATE GCU_CONFIGURACION
    Set CNF_AUDUSRMOD = p_USERID
    Where CNF_VEHID = p_VEHID
    AND CNF_CARID = p_CARID;
    
    DELETE GCU_CONFIGURACION
    WHERE CNF_VEHID = p_VEHID
    AND CNF_CARID = p_CARID; 

Exception WHEN OTHERS THEN
    raise_application_error (-20029, 'Error al eliminar la caracterstica: '||p_VEHID);
    
End Delete_Caracteristica;

END PKG_GCU_VEHICULO;
/


CREATE OR REPLACE package body     PKG_DWH_CARGA IS


Procedure Movimiento_Comercial Is

Begin 

    DELETE DWH_MOVIMIENTO_COMERCIAL; 
     
     Insert into DWH_MOVIMIENTO_COMERCIAL
     Select VEH_MODID, MOD_NOMBRE, VEH_BASTIDOR, VEH_MATRICULA, 
                VEH_COLOR, NVL(VEN_FECHA,VEH_AUDFALTA) FECHA, 
                FUN_GET_TOTAL_FACTURA(VEN_FACID) AS TOTAL, 
                VEN_EMPID, VEH_VENDIDO, VEH_CONID, CON_NOMBRE
    From GCU_VEHICULO 
    Left Join GCU_VENTA on VEN_VEHID = VEH_ID
    Join GCU_MODELO on MOD_ID = VEH_MODID 
    Join GCU_CONCESIONARIO on VEH_CONID = CON_ID;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar movimientos comerciales ');    

End Movimiento_Comercial; 
       
Procedure Vehiculo Is

Begin 

    DELETE DWH_VEHICULO; 
     
     Insert into DWH_VEHICULO
     Select VEH_ID, VEH_BASTIDOR, VEH_MATRICULA, VEH_MODID, 
                MOD_NOMBRE, VEH_COLOR, VEH_AUDFALTA, VEH_VENDIDO, 
                VEH_CONID, CON_NOMBRE, CAR_DESCRIPCION
     From GCU_VEHICULO
     Join GCU_MODELO ON VEH_MODID = MOD_ID
     Join GCU_CONCESIONARIO ON VEH_CONID = CON_ID
     Left Join GCU_CONFIGURACION ON CNF_VEHID = VEH_ID
     Left Join GCU_CARACTERISTICA ON CNF_CARID = CAR_ID;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar vehculos ');    

End Vehiculo; 

Procedure Empleado Is

Begin 

    DELETE DWH_EMPLEADO; 
     
    Insert Into DWH_EMPLEADO
    Select EMP_ID, EMP_CONID, CON_NOMBRE, EMP_NOMBRE, EMP_APELLIDOS, 
              EMP_DIRECCION, EMP_TELEFONO, EMP_NSS, EMP_DNI, EMP_SUELDO,
              EMP_COSTE,  EMP_JEFE, EMP_TIPOEMP, EMP_AUDFALTA 
    From GCU_EMPLEADO
    Join GCU_CONCESIONARIO On CON_ID = EMP_CONID;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar empleados ');    

End Empleado;

Procedure Cliente Is

Begin 

    DELETE DWH_CLIENTE; 
     
     Insert into DWH_CLIENTE
     Select CLI_ID, CLI_NOMBRE, CLI_APELLIDO, CLI_TELEFONO, CLI_EMAIL,
                CLI_PROFESION, CLI_FNAC, CLI_AUDFALTA 
     From GCU_CLIENTE;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar clientes ');    

End Cliente;  

Procedure Catalogo Is

Begin 

    DELETE DWH_CATALOGO; 
     
    Insert into DWH_CATALOGO
    Select CAT_MODID, MOD_NOMBRE, CAT_CARID, CAR_DESCRIPCION, 
            CAT_EXTRA, CAT_PVP  
    From GCU_CATALOGO
    Join GCU_MODELO on CAT_MODID = MOD_ID
    Join GCU_CARACTERISTICA on CAR_ID = CAT_CARID;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar catlogo ');    

End Catalogo; 

Procedure Reparacion Is

Begin 

    DELETE DWH_REPARACION; 
     
    Insert into DWH_REPARACION
    Select REP_FECHAINICIO, REP_FECHAFIN, REP_REVISION, REP_FACID,  
              REP_EMPID, TAR_CONCEPTO, TAR_HORAS, TAR_EMPID, 
              TAR_IMPORTE, TAR_FACTURABLE
    From GCU_REPARACION
    Join GCU_TAREA On REP_ID = TAR_REPID;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar reparacin ');    

End Reparacion; 

Procedure Facturacion Is

Begin 

    DELETE DWH_FACTURACION; 
     
    Insert into DWH_FACTURACION
    Select FAC_ID, FAC_CONTABILIZADA, FAC_FECHA, 
              FUN_GET_TOTAL_FACTURA(FAC_ID), LIN_CONCEPTO, LIN_PVP 
    From GCU_FACTURA
    Join GCU_LINEAFACTURA On FAC_ID = LIN_FACID;

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al cargar facturacin ');    

End Facturacion; 

Procedure Carga Is

Begin
    
    --
    -- Realiza la carga de todas las tablas. 
    --
    Movimiento_Comercial;
    Vehiculo;
    Empleado;
    Cliente;
    Catalogo;
    Reparacion;
    Facturacion; 

End Carga;

END PKG_DWH_CARGA;
/


CREATE OR REPLACE package body     PKG_GCU_FACTURACION IS

Procedure Genera_Factura_Venta
(p_FACID In Number, 
p_VEHID In Number,
p_USERID In Number) Is

Cursor c_VENTA Is
    --
    --Obtenemos el precio del modelo base: suma de sus caracteristicas bsicas (no extra)
    --
    SELECT 'Modelo Base' AS CONCEPTO, SUM(CAT_PVP) AS IMPORTE, 0 AS ORDEN 
    FROM  GCU_VEHICULO
    JOIN GCU_CATALOGO ON VEH_MODID  = CAT_MODID
    WHERE VEH_ID = p_VEHID
    AND CAT_EXTRA = '0'
    GROUP BY VEH_ID
    UNION
    --
    -- Obtenemos las caractersticas extra
    --
    SELECT CAR_DESCRIPCION AS CONCEPTO, CAT_PVP AS IMPORTE, 1 AS ORDEN
    FROM GCU_VEHICULO
    JOIN GCU_CONFIGURACION ON VEH_ID = CNF_VEHID
    JOIN GCU_CATALOGO ON VEH_MODID = CAT_MODID AND CNF_CARID = CAT_CARID
    JOIN GCU_CARACTERISTICA ON CAT_CARID = CAR_ID
    WHERE CNF_VEHID = p_VEHID
    AND CAT_EXTRA = '1'
    ORDER BY ORDEN;
    
Begin 

    For v in c_VENTA Loop
        Insert into GCU_LINEAFACTURA
        (LIN_FACID, LIN_CONCEPTO, LIN_PVP, LIN_AUDUSRALTA)
        Values
        (p_FACID, v.CONCEPTO, v.IMPORTE, p_USERID);
    End Loop; 
    
Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20020, 'Error al generar lneas de factura: '||p_FACID);   

End Genera_Factura_Venta;

Procedure Facturar_Venta( 
p_VENID In Number, 
p_VEHID In Number,
p_USERID In Number, 
p_FACID Out Number)Is

--
-- Facturacin de la venta. 
--

Begin 

    Insert into GCU_FACTURA (FAC_FECHA, FAC_AUDUSRALTA)
    Values (Sysdate, p_USERID) RETURNING FAC_ID Into p_FACID; 
       
    Genera_Factura_Venta(p_FACID, p_VEHID, p_USERID);
    
    Update GCU_VENTA
    Set VEN_FACID = p_FACID,
          VEN_AUDUSRMOD = p_USERID
    Where VEN_ID = p_VENID; 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20021, 'Error al facturar la venta: '||p_VENID);   

End Facturar_Venta;

Procedure Genera_Factura_Reparacion
(p_FACID In Number, 
p_REPID In Number,
p_USERID In Number) Is

Cursor c_REPARACION Is
    --
    --Obtenemos las tareas facturables.
    --
  SELECT TAR_CONCEPTO AS CONCEPTO, NVL(TAR_IMPORTE,0) AS IMPORTE FROM GCU_TAREA
    WHERE TAR_REPID = p_REPID
    AND TAR_FACTURABLE= '1';

Begin 

    For v in c_REPARACION Loop
        Insert into GCU_LINEAFACTURA
        (LIN_FACID, LIN_CONCEPTO, LIN_PVP, LIN_AUDUSRALTA)
        Values
        (p_FACID, v.CONCEPTO, v.IMPORTE, p_USERID);
    End Loop;
    
Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20020, 'Error al generar lneas de factura: '||p_FACID);   

End Genera_Factura_Reparacion;

Procedure Facturar_Reparacion( 
p_REPID In Number, 
p_USERID In Number, 
p_FACID Out Number)Is

--
-- Facturacin de la reparacin. 
--

Begin 

    Insert into GCU_FACTURA (FAC_FECHA, FAC_AUDUSRALTA)
    Values (Sysdate, p_USERID) RETURNING FAC_ID Into p_FACID; 
       
    Genera_Factura_Reparacion(p_FACID, p_REPID, p_USERID);
    
    Update GCU_REPARACION
    Set REP_FACID = p_FACID,
          REP_AUDUSRMOD = p_USERID
    Where REP_ID = p_REPID; 

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20022, 'Error al facturar la reparacion: '||p_REPID);   

End Facturar_Reparacion;

END PKG_GCU_FACTURACION;
/


CREATE OR REPLACE package body     PKG_GCU_TALLER IS

Procedure Nueva_Reparacion(
p_CLIENTE In Varchar2,
p_TELEFONO In Varchar2, 
p_REVISION In Varchar2,
p_VEHID In Number, 
p_EMPID In Number,
p_CLIID In Number,
p_USERID In Number, 
p_REPID Out Number) Is

v_CLIENTE GCU_CLIENTE.CLI_NOMBRE%Type;
v_TELEFONO GCU_CLIENTE.CLI_TELEFONO%Type;

Begin 
    --
    -- Si el cliente est registrado, obtenemos su nombre y telfono de la ficha
    --
    v_CLIENTE := p_CLIENTE; 
    v_TELEFONO := p_TELEFONO; 
    
    If (p_CLIID Is Not Null) And (p_CLIENTE Is Null) And (p_TELEFONO Is Null) Then
        Select CLI_NOMBRE, CLI_TELEFONO
        Into v_CLIENTE, v_TELEFONO 
        From GCU_CLIENTE
        Where CLI_ID = p_CLIID;
    End If;
    
    Insert into GCU_REPARACION
    (REP_FECHAINICIO, REP_CLIENTE, REP_TELEFONO, REP_REVISION, REP_VEHID, REP_EMPID, REP_AUDUSRALTA)
    Values
    (Sysdate, v_CLIENTE, v_TELEFONO, p_REVISION, p_VEHID, p_EMPID, p_USERID)
    RETURNING REP_ID Into p_REPID; 
    
/*Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al crear reparacin: '||p_VEHID);*/
       
End Nueva_Reparacion;

Procedure Nueva_Tarea(
p_REPID In Number,
p_CONCEPTO In Varchar2,
p_HORAS In Number,
p_EMPID In Number,
p_FACTURABLE In Varchar2,
p_IMPORTE In Number,
p_USERID In Number,
p_TARID Out Number)Is 

Begin
    Insert into GCU_TAREA
    (TAR_REPID, TAR_CONCEPTO, TAR_HORAS, TAR_EMPID, TAR_FACTURABLE, TAR_IMPORTE, TAR_AUDUSRALTA)
    Values
    (p_REPID, p_CONCEPTO, p_HORAS, p_EMPID, p_FACTURABLE, p_IMPORTE, p_USERID)
    RETURNING TAR_ID Into p_TARID;

/*Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al crear la tarea '||p_REPID);*/
       
End Nueva_Tarea;

Procedure Modifica_Tarea(
p_REPID In Number,
p_TARID In Number,
p_CONCEPTO In Varchar2,
p_HORAS In Number,
p_EMPID In Number,
p_FACTURABLE In Varchar2,
p_IMPORTE In Number,
p_USERID In Number)Is 

Begin
    UPDATE GCU_TAREA
    Set TAR_CONCEPTO = p_CONCEPTO,
    TAR_HORAS = p_HORAS, 
    TAR_EMPID = p_EMPID,
    TAR_FACTURABLE = p_FACTURABLE,
    TAR_IMPORTE = p_IMPORTE,
    TAR_AUDUSRMOD = p_USERID
    WHERE TAR_ID = p_TARID
    AND TAR_REPID = p_REPID;
    
Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al modificar la tarea: '||p_TARID||' * '||p_REPID);
    
End Modifica_Tarea;

Procedure Elimina_Tarea(
p_REPID In Number,
p_TARID In Number,
p_USERID In Number)Is 

Begin
    UPDATE GCU_TAREA
    Set  TAR_AUDUSRMOD = p_USERID
    WHERE TAR_ID = p_TARID
    AND TAR_REPID = p_REPID;
    
    DELETE GCU_TAREA
    Where TAR_ID = p_TARID
    And TAR_REPID = p_REPID;
    
Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20001, 'Error al eliminar la tarea: '||p_TARID||' * '||p_REPID);
    
End Elimina_Tarea;

Procedure Cierra_Reparacion (
p_REPID In Number, 
p_USERID In Number) Is

v_FACID GCU_FACTURA.FAC_ID%Type;

Begin  
    
    PKG_GCU_FACTURACION.FACTURAR_REPARACION(p_REPID, p_USERID, v_FACID); 
    
    UPDATE GCU_REPARACION
    Set REP_FECHAFIN = SYSDATE,
    REP_FACID = v_FACID,
    REP_AUDUSRMOD = p_USERID
    Where REP_ID = p_REPID;
    
End Cierra_Reparacion;

END PKG_GCU_TALLER;
/


CREATE OR REPLACE package body     PKG_GCU_COMERCIAL IS


Procedure Nueva_Venta(
p_VEHID In Number, 
p_EMPID In Number,
p_CLIID In Varchar2, 
p_USERID In Number) Is

--
-- Crea una nueva venta de un vehculo. Al realizar una venta se crea la factura. 
--

v_VENID GCU_VENTA.VEN_ID%Type; 

v_FACID GCU_FACTURA.FAC_ID%Type;

Begin 

     Insert into GCU_VENTA
    (VEN_VEHID, VEN_CLIID, VEN_FECHA, VEN_EMPID, VEN_AUDUSRALTA)
    VALUES
    (p_VEHID, p_CLIID, SYSDATE, p_EMPID, p_USERID)
    RETURNING VEN_ID Into v_VENID;
    
    --
    -- Marcamos el vehculo como vendido
    --
    Update GCU_VEHICULO
    Set VEH_VENDIDO = '1',
        VEH_AUDUSRMOD = p_USERID
    Where VEH_ID = p_VEHID;
    
    --
    -- Emitimos la factura de la venta. 
    -- 
    PKG_GCU_FACTURACION.Facturar_Venta(v_VENID, p_VEHID, p_USERID, v_FACID);

Exception WHEN OTHERS THEN
    
    Raise_Application_Error(-20019, 'Error al crear la venta: '||p_VEHID|| ' * '||p_CLIID);    

End Nueva_Venta; 
       
END PKG_GCU_COMERCIAL;
/